
#ifndef _DOS_H_
#define _DOS_H_

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdarg.h>
#include <allegro.h>
#include <audio.h>
#include <zlib.h>

/* Global data */
extern int video_driver;
extern int video_width;
extern int video_height;
extern int joy_driver;
extern BITMAP *bmp;

/* Function prototypes */
void tick_handler(void);
int load_rom(const char *filename);
void update_input(void);
void init_machine(void);
void trash_machine(void);
void update_palette(void);
void load_sram(const char *filename);
void save_sram(const char *filename);
void parse_args(int argc, char **argv);
int check_key(int code);

#endif /* _DOS_H_ */
