
#ifndef _BLIT_H_
#define _BLIT_H_

/* From blit.s */
extern void blit_sms_expand_scanlines_mmx    (BITMAP *src, BITMAP *dst);
extern void blit_sms_expand_scanlines        (BITMAP *src, BITMAP *dst);
extern void blit_sms_expand_mmx_vs           (BITMAP *src, BITMAP *dst);
extern void blit_sms_expand_mmx              (BITMAP *src, BITMAP *dst);
extern void blit_sms_expand_vs               (BITMAP *src, BITMAP *dst);
extern void blit_sms_expand                  (BITMAP *src, BITMAP *dst);
extern void blit_gg_expand_scanlines_mmx     (BITMAP *src, BITMAP *dst);
extern void blit_gg_expand_scanlines         (BITMAP *src, BITMAP *dst);
extern void blit_gg_expand_mmx_vs            (BITMAP *src, BITMAP *dst);
extern void blit_gg_expand_mmx               (BITMAP *src, BITMAP *dst);
extern void blit_gg_expand_vs                (BITMAP *src, BITMAP *dst);
extern void blit_gg_expand                   (BITMAP *src, BITMAP *dst);

/* from 'blit.inc' */
void blit_sms                                (BITMAP *src, BITMAP *dst);
void blit_sms_scanlines                      (BITMAP *src, BITMAP *dst);
void blit_sms_scale                          (BITMAP *src, BITMAP *dst);
void blit_sms_scale_scanlines                (BITMAP *src, BITMAP *dst);
void blit_gg                                 (BITMAP *src, BITMAP *dst);
void blit_gg_scanlines                       (BITMAP *src, BITMAP *dst);
void blit_gg_scale                           (BITMAP *src, BITMAP *dst);
void blit_gg_scale_scanlines                 (BITMAP *src, BITMAP *dst);

/* List of blitter functions */
void (*blit_table[])(BITMAP *src, BITMAP *dst) =
{
    blit_sms                         , /* 00 */
    blit_gg                          , /* 01 */
    blit_sms_scanlines               , /* 02 */
    blit_gg_scanlines                , /* 03 */
    blit_sms_scale                   , /* 04 */
    blit_gg_scale                    , /* 05 */
    blit_sms_scale_scanlines         , /* 06 */
    blit_gg_scale_scanlines          , /* 07 */
    blit_sms_expand                  , /* 08 */
    blit_gg_expand                   , /* 09 */
    blit_sms_expand_scanlines        , /* 0A */
    blit_gg_expand_scanlines         , /* 0B */
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,

    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    blit_sms_expand_mmx              , /* 18 */
    blit_gg_expand_mmx               , /* 19 */
    blit_sms_expand_scanlines_mmx    , /* 1A */
    blit_gg_expand_scanlines_mmx     , /* 1B */
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,

    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,
    blit_sms_expand_vs               , /* 28 */
    blit_gg_expand_vs                , /* 29 */
    NULL                             ,            
    NULL                             ,            
    NULL                             ,
    NULL                             ,
    NULL                             ,
    NULL                             ,

    NULL                             , 
    NULL                             , 
    NULL                             , 
    NULL                             , 
    NULL                             , 
    NULL                             , 
    NULL                             , 
    NULL                             , 
    blit_sms_expand_mmx_vs           , /* 38 */
    blit_gg_expand_mmx_vs            , /* 39 */
    NULL                             ,         
    NULL                             ,         
    NULL                             , 
    NULL                             , 
    NULL                             , 
    NULL                             , 
};

#endif /* _BLIT_H_ */
